#ifndef MCST_RT_U_H_
#define MCST_RT_U_H_

#define CONFIG_MCST
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <linux/unistd.h>
#include <time.h>
#include <linux/mcst_rt.h>

#ifdef __cplusplus
extern "C" {
#endif
__BEGIN_DECLS

#define el_posix(req, a1, a2, a3, a4) \
        syscall(__NR_el_posix, req, a1, a2, a3, a4)

long el_get_cpu_id(void);
long el_get_cpus_num(void);
long el_set_irq_mask(long irq_mask, long cpu_mask);
long el_get_irq_mask(long irq_mask);	// returns cpu_mask for irq_mask set
long el_set_rtmode(long mode);
long el_set_rts_active(long mask);
long el_get_rts_active(void);
long el_get_usec(unsigned long long *);
long el_get_nsec(unsigned long long *);
long el_get_cpus_mask(void);
long el_tick_thread_start(long delay_in_jiffies);
long el_tick_thread_cont(unsigned int *, int *);
long el_tick_thread_stop(void);
long el_set_net_rt(void);
long el_unset_net_rt(void);
long el_set_mlock_control(void);
long el_unset_mlock_control(void);
long el_atomic_add(int *target, int delta, int *dest);
long el_set_apic_timer(int mode);
long el_get_cpu_freq(void);
long el_get_schedule_times(unsigned long long *m, int sz);
long el_user_tick(long);
long el_set_cpu_rt(long on);
	// For compatibility to 2.6.33. Not impemented in 2.6.14
long el_timerfd_create(void);
long el_timerfd_settime(int fd, const struct itimerspec *utmr);

typedef struct pool_rt pool_rt_t;
int get_pool_rt(pool_rt_t** pool, int slote_num, size_t slote_size);
void free_pool(pool_rt_t* pool);
void* get_area(pool_rt_t* pool);
int free_area(void* area, pool_rt_t* pool);


	/*   Net RT stuff */


struct el_netdev;
typedef struct el_netdev *   el_netdev_t;


el_netdev_t el_create_netdev(char *interface, unsigned char *dst);
int        el_open_netdev(el_netdev_t netdev);
void        el_close_netdev(el_netdev_t netdev);
int el_read_netdev(el_netdev_t netdev, void *buf, int *len, int *proto,
                                  int *skipped, int timeout);
int el_write_netdev(el_netdev_t netdev, void *buf, int len, int proto);

__END_DECLS
#ifdef __cplusplus
}
#endif
#endif /* MCST_RT_U_H_ */

